use ads1256_types::{Buffer, Config, DataRate, Gain, Multiplexer, MuxInput};

#[cfg_attr(feature = "defmt", derive(defmt::Format))]
#[derive(Copy, Clone, Eq, PartialEq, Debug)]
#[repr(u8)]
pub enum Differential {
    AIn0 = Multiplexer::setting(MuxInput::AIn0, MuxInput::AIn1).0,
    AIn1 = Multiplexer::setting(MuxInput::AIn2, MuxInput::AIn3).0,
    AIn2 = Multiplexer::setting(MuxInput::AIn4, MuxInput::AIn5).0,
    AIn3 = Multiplexer::setting(MuxInput::AIn6, MuxInput::AIn7).0,
}

impl Into<Multiplexer> for Differential {
    #[inline(always)]
    fn into(self) -> Multiplexer {
        Multiplexer(self as u8)
    }
}

#[cfg_attr(feature = "defmt", derive(defmt::Format))]
#[derive(Copy, Clone, Eq, PartialEq, Debug)]
#[repr(u8)]
pub enum SingleEnded {
    AIn0 = Multiplexer::setting(MuxInput::AIn0, MuxInput::Common).0,
    AIn1 = Multiplexer::setting(MuxInput::AIn1, MuxInput::Common).0,
    AIn2 = Multiplexer::setting(MuxInput::AIn2, MuxInput::Common).0,
    AIn3 = Multiplexer::setting(MuxInput::AIn3, MuxInput::Common).0,
    AIn4 = Multiplexer::setting(MuxInput::AIn4, MuxInput::Common).0,
    AIn5 = Multiplexer::setting(MuxInput::AIn5, MuxInput::Common).0,
    AIn6 = Multiplexer::setting(MuxInput::AIn6, MuxInput::Common).0,
    AIn7 = Multiplexer::setting(MuxInput::AIn7, MuxInput::Common).0,
}

impl Into<Multiplexer> for SingleEnded {
    #[inline(always)]
    fn into(self) -> Multiplexer {
        Multiplexer(self as u8)
    }
}
